#include "allwind.h"

/* status window members */

TMyStatusWindow::TMyStatusWindow(PTWindowsObject AParent, LPSTR ATitle)
: TDialog(AParent, ATitle)
   {
   }

TMyStatusWindow::~TMyStatusWindow()
   {
   }

/* The next 13 routines just update it's corresponding field */

void update_status_turtleposition(void) /*routine*/
   {
   sprintf(YABuffer,"%1.2lf,%1.2lf",turtle_x,turtle_y);
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_TURTLEPOSITION, WM_SETTEXT, 0, (DWORD)YABuffer);
   }

void update_status_pencolor(void) /*routine*/
   {
   sprintf(YABuffer,"%d,%d,%d",(int)dpenr,(int)dpeng,(int)dpenb);
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_PENCOLOR, WM_SETTEXT, 0, (DWORD)YABuffer);
   }

void update_status_floodcolor(void) /*routine*/
   {
   sprintf(YABuffer,"%d,%d,%d",(int)dfldr,(int)dfldg,(int)dfldb);
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_FLOODCOLOR, WM_SETTEXT, 0, (DWORD)YABuffer);
   }

void update_status_screencolor(void) /*routine*/
   {
   sprintf(YABuffer,"%d,%d,%d",(int)dscnr,(int)dscng,(int)dscnb);
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_SCREENCOLOR, WM_SETTEXT, 0, (DWORD)YABuffer);
   }

void update_status_paletteuse(void) /*routine*/
   {
   if (EnablePalette)
      {
      sprintf(YABuffer,"%d",MyLogPalette->palNumEntries);
      }
   else
      {
      sprintf(YABuffer,"%s","N/A");
      }
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_PALETTEUSE, WM_SETTEXT, 0, (DWORD)YABuffer);
   }

void update_status_penwidth(void) /*routine*/
   {
   sprintf(YABuffer,"%d",width);
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_PENWIDTH, WM_SETTEXT, 0, (DWORD)YABuffer);
   }

void update_status_turtleheading(void) /*routine*/
   {
   sprintf(YABuffer,"%1.2lf",turtle_heading);
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_TURTLEHEADING, WM_SETTEXT, 0, (DWORD)YABuffer);
   }

void update_status_penstyle(void) /*routine*/
   {
   if (current_write_mode==XOR_PUT) sprintf(YABuffer,"Reverse"); else sprintf(YABuffer,"Normal");
   if (in_erase_mode) sprintf(YABuffer,"Erase");
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_PENSTYLE, WM_SETTEXT, 0, (DWORD)YABuffer);
   }

void update_status_pencontact(void) /*routine*/
   {
   if (pen_vis == 0) sprintf(YABuffer,"Down"); else sprintf(YABuffer,"Up");
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_PENCONTACT, WM_SETTEXT, 0, (DWORD)YABuffer);
   }

void update_status_turtlevisability(void) /*routine*/
   {
   if (turtle_shown) sprintf(YABuffer,"Shown"); else sprintf(YABuffer,"Hidden");
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_TURTLEVISABILITY, WM_SETTEXT, 0, (DWORD)YABuffer);
   }

void update_status_fontsize(void) /*routine*/
   {
   sprintf(YABuffer,"%d",FontRec.lfHeight);
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_FONTSIZE, WM_SETTEXT, 0, (DWORD)YABuffer);
   }

void update_status_fontwieght(void) /*routine*/
   {
   sprintf(YABuffer,"%d",FontRec.lfWeight);
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_FONTWEIGHT, WM_SETTEXT, 0, (DWORD)YABuffer);
   }

void update_status_fontname(void) /*routine*/
   {
   sprintf(YABuffer,"%s",FontRec.lfFaceName);
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_FONTNAME, WM_SETTEXT, 0, (DWORD)YABuffer);
   }

void update_status_evals(void) /*routine*/
   {
   sprintf(YABuffer,"%ld",eval_count);
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_EVALS, WM_SETTEXT, 0, (DWORD)YABuffer);
   }

void update_status_memory(void) /*routine*/
   {
   sprintf(YABuffer,"%ld Nodes",(long)((long)memory_count*(long)SEG_SIZE));
   ((TMyStatusWindow *)((TMyWindow *)MainWindowx)->StatusWindow)->
   SendDlgItemMsg(ID_MEMORY, WM_SETTEXT, 0, (DWORD)YABuffer);
   }
